﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
  public partial class Form1 : Form
  {
    public Form1()
    {
      InitializeComponent();
    }

    private void textBox1_KeyPress(object sender, KeyPressEventArgs e)
    {
      e.Handled = true;//anything not specified below is not allowed
      
      if (char.IsDigit(e.KeyChar)//[0-9]
        || char.IsUpper(e.KeyChar)//[A-Z] 
        || e.KeyChar == '-'
        || e.KeyChar == '\b')//backspace allowed
      {
        e.Handled = false;//allowed with no processing
      }
      else if (char.IsLower(e.KeyChar))
      {
        SendKeys.Send(new string(char.ToUpperInvariant(e.KeyChar), 1));
      }
    }
  }
}
